/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */

import {Component} from '@angular/core';
import {Clipboard} from '@angular/cdk/clipboard';


@Component({
  selector: 'clipboard-demo',
  styleUrls: ['clipboard-demo.css'],
  templateUrl: 'clipboard-demo.html',
})
export class ClipboardDemo {
  attempts = 3;

  value = `Did you ever hear the tragedy of Darth Plagueis The Wise? I thought not. It's not ` +
          `a story the Jedi would tell you. It's a Sith legend. Darth Plagueis was a Dark Lord ` +
          `of the Sith, so powerful and so wise he could use the Force to influence the ` +
          `midichlorians to create life… He had such a knowledge of the dark side that he could ` +
          `even keep the ones he cared about from dying. The dark side of the Force is a pathway ` +
          `to many abilities some consider to be unnatural. He became so powerful… the only ` +
          `thing he was afraid of was losing his power, which eventually, of course, he did. ` +
          `Unfortunately, he taught his apprentice everything he knew, then his apprentice ` +
          `killed him in his sleep. Ironic. He could save others from death, but not himself.`;

  constructor(private _clipboard: Clipboard) {}

  copyViaService() {
    this._clipboard.copy(this.value);
  }
}
